(define-module (ordo handler)
  #:use-module (srfi srfi-9)
  #:use-module (ordo logger)
  #:export (make-handler
            handler?
            handler-name
            handler-action
            handler
            run-handler))

(define-record-type <handler>
  (make-handler name action)
  handler?
  (name handler-name)
  (action handler-action))

(define* (handler #:key name action)
  (make-handler name action))

(define (run-handler h conn)
  (log-msg 'NOTICE "Running handler: " (handler-name h))
  ((handler-action h) conn))
